package jp.oarts.pirka.tools.message;


/**
 * bZ[W擾NX
 * @version     $Revision: 1.4 $ $Date: 2010/11/10 10:02:20 $
 * @author      Akihiko.Furukawa , Oriental Arts
 *
 */
public class MessageUtil {
	/* -------== 萔 ==------- */
	/* -------== tB[h ==------- */
	private MessagePacker messagePacker;
	
	/* -------== RXgN^ ==------- */
	/**
	 * RXgN^B
	 */
	public MessageUtil(MessagePacker messages){
		this.messagePacker = messages;
	}
	
	/* -------== \bh ==------- */
	/**
	 * bZ[W1擾
	 * @param code
	 * @return
	 */
	public String getMessage(String code){
		String ret = "";
		if (messagePacker==null){
			// bZ[WZbgĂȂƂ ""Ԃ
			return ret;
		}
		ret = (String)messagePacker.getMessage().get(code);
		if (ret==null) {
			ret = "";
		}
		return ret;
	}
	

	
	/**
	 * bZ[W ϕ ̕ɒubZ[W𐶐܂
	 * ϕ񕔕 $1,$2 ̗l$n`Ŏw肵ĉB(n͌ԂȂA19̘A)
	 * ) bZ[W`  F  $1 ɂ $2 ܂ $3  w肵ĉB
	 *  String[] itemName = {"","cƕ","J"};
	 *  getReplaceMessage(xxxx, String[] itemName)
	 *  	
	 *  郁bZ[W  F  ɂ́Acƕ ܂ J w肵ĉB
	 * ̒l $n ɊY镶񂪊܂܂Ƃ́Aɓ삵ȂƂ܂B
	 * $n͕̐擪AԂɎw肵ĂȂƁAɓ삵܂B
	 * 
	 * @param code
	 * @param itemName
	 * @return
	 */
	public String getMessage(String code, String[] itemName){
		String ret = "";
		String msg = getMessage(code);
		if (msg!=null && msg.length() > 0){
			//$nitemNameɒu
			String newmsg = msg;
			int itemCount = 1;
			int startPos = 0;
			for (String item:itemName){
				String replaceStringMark = "$"+itemCount;
				int pos = newmsg.indexOf(replaceStringMark, startPos);
				if (pos>=0){
					String repMsg;
					repMsg = newmsg.substring(0,pos) + item + newmsg.substring(pos+replaceStringMark.length(),newmsg.length());
					newmsg = repMsg;
					startPos = pos+item.length();
				}
				itemCount++;
			}
			ret = newmsg;
		}
		return ret;
	}
	
//--- TEST -------------------------------------------------------------------------------------------
	public static void main(String[] args){
		System.out.println("*** Test Start ***");
		MessageUtil mu = new MessageUtil(null);
		System.out.println("1." + mu.getMessage(""));
		System.out.println("2." + mu.getMessage("abc"));
		String[] items = {"","","$4","Ă","Ȃɂʂ˂","͂Ђӂւ","܂݂ނ߂","","","","ABC","EFG","HIJ","KLM"};
		System.out.println("3." + mu.getMessage("",items));
		System.out.println("4." + mu.getMessage("abc",items));
		//=========
		MessagePacker msgs = new MessagePacker();
		msgs.add("MSG01", "bZ[W01");
		msgs.add("MSG02", "bZ[W02");
		msgs.add("MSG11", "bZ[W11 $1");
		msgs.add("MSG12", "bZ[W12 $1 : $2");
		msgs.add("MSG13", "bZ[W13 $1 : $2 : $3 : $4: $5: $6: $7: $8: $9: $10: $11: $12");
		mu = new MessageUtil(msgs);
		System.out.println("5." + mu.getMessage(""));
		System.out.println("6." + mu.getMessage("abc"));
		System.out.println("7." + mu.getMessage("MSG01"));
		System.out.println("8." + mu.getMessage("MSG11"));
		System.out.println("9." + mu.getMessage("MSG01",items));
		System.out.println("10." + mu.getMessage("MSG11",items));
		System.out.println("12." + mu.getMessage("MSG12",items));
		
		System.out.println("13." + mu.getMessage("MSG13",items));

	}
}
