package jp.oarts.pirka.tools.checker;

import jp.oarts.pirka.core.util.check.Checker;
import jp.oarts.pirka.core.util.check.PirkaCheckException;

/**
 * pirkaChecker gNX̒ۃNX
 * @author oa
 *
 */
@SuppressWarnings("serial")
public abstract class PirkaToolsCheckerAbstract implements Checker {

	protected String msg = null;
	protected Checker[] checkers = null;

	/**
	 * RXgN^
	 * @param msg
	 * @param checkers
	 */
	protected PirkaToolsCheckerAbstract(String msg, Checker... checkers) {
		this.msg = msg;
		this.checkers = checkers;
	}

	
	/**
	 * `FbN
	 */
	@Override
	public void check(String value) throws PirkaCheckException {
		try {
			for(Checker checker : checkers){
				checker.check(value);
			}
		} catch (PirkaCheckException e) {
			if (msg != null) {
				throw new PirkaCheckException(msg);
			} else {
				throw e;
			}
		}

	}

}
