package jp.oarts.pirka.tools.checker;

import java.math.BigDecimal;

import jp.oarts.pirka.core.util.check.PirkaCheckerNumericRange;

/**
 * pirkaTools`FbJ[ Fl͈̓`FbN
 * @version     $Revision: 1.2 $ $Date: 2010/11/05 08:24:16 $
 * @author @@@@@Akihiko Furukawa, Oriental Arts
 *
 */
@SuppressWarnings("serial")
public class PirkaToolsCheckerNumericRange extends PirkaToolsCheckerAbstract {

	/**
	 * int ͈̔̓`FbN
	 * @param msg
	 * @param minInt
	 * @param maxInt
	 */
	public PirkaToolsCheckerNumericRange(String msg, int minInt, int maxInt) {
		super(msg, new PirkaCheckerNumericRange(minInt, maxInt));
	}

	/**
	 * long ͈̔̓`FbN
	 * @param msg
	 * @param minLong
	 * @param maxLong
	 */
	public PirkaToolsCheckerNumericRange(final String msg, final long minLong, final long maxLong) {
		super(msg, new PirkaCheckerNumericRange(minLong, minLong));
	}

	/**
	 * BigDecimal ͈̔̓`FbN
	 * @param msg
	 * @param minBigDecimal
	 * @param maxBigDecimal
	 */
	public PirkaToolsCheckerNumericRange(final String msg, final BigDecimal minBigDecimal, final BigDecimal maxBigDecimal) {
		super(msg, new PirkaCheckerNumericRange(minBigDecimal, maxBigDecimal));
	}
}
